//---------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>

//---------------------------------------------------------------------------


const MAXIMO = 30000;
///*****************************************************************************
/* Generador Aleatorio */
void GeneraAleatorio(char *Input,int P,int N, int M,int A)
{
int i,j,Count;
int *Lista;
Lista = new int[P];
FILE *Salida = fopen(Input,"w+t");

// Imprimos el nmero de puertas, el nmero de botones y el nmero
// de piedras que acciona cada puerta.
fprintf(Salida,"%d\n%d\n%d\n",P,N,M);

for(i = 0; i < N; i++)
  {
  // Inicializmaos la lista con ceros.
  for(j = 0; j < P; j++)
    { Lista[j] = 0; }

  // Seleccionamos M puerta de la P disponibles
  for(j = 0; j < M; j++)
    {
    Count = random(P);
    while( Lista[Count] == 1 )
      { Count = (Count+1)%P; }
    Lista[Count] = 1;
    }

  // Imprimimos las piedas seleccionadas
  for(j = 0; j < P; j++)
    {
    if( Lista[j] == 1 )
      { fprintf(Salida,"%d ",j+1); }
    }

  // Imprimimos el salto de lnea
  fprintf(Salida,"\n");
  }

// Imprimimos el nmero debotones que accionamos.
fprintf(Salida,"%d\n",A);
// Imprimos los botones accionados
for(i = 0; i < A; i++)
  { fprintf(Salida,"%d ",random(N)+1); }

fclose(Salida);
delete[] Lista;
}
///*****************************************************************************
int* Soluciona(int P,int N,int M,int A,int **PiedraPuerta,int *Presionados)
{
int i,j,*Resp;
int *Push;

Push = new int[N];
for(i = 0; i < N; i++)
  { Push[i] = 0; }

for(i = 0; i < A; i++)
  { Push[Presionados[i]]++; }

Resp = new int[P];
for(i = 0; i < P; i++)
  { Resp[i] = 0; }

for(i = 0; i < N; i++)
  {
  if( Push[i]%2 == 1 )
    {
    for(j = 0; j < M; j++)
      { Resp[PiedraPuerta[i][j]]++; }
    }
  }

delete[] Push;
return Resp;
}
///*****************************************************************************
int main(void)
{
int i,j,P,N,M,A,Count;
int *Resp,**PiedrasPuerta;
int *Presionados;
FILE *Input,*Output;


//char Entrada[12];
//randomize();
//fscanf(Input,"%s %d %d %d %d",&Entrada,&P,&N,&M,&A);
//GeneraAleatorio(Entrada,P,N,M,A);

Input = fopen("input.txt","r+t");
fscanf(Input,"%d %d %d",&P,&N,&M);
PiedrasPuerta = new int*[N];
for(i = 0; i < N; i++)
  {
  PiedrasPuerta[i] = new int[M];
  for(j = 0; j < M; j++)
	 {
	 fscanf(Input,"%d",&PiedrasPuerta[i][j]);
	 PiedrasPuerta[i][j]--;
	 }
  }
fscanf(Input,"%d",&A);
Presionados = new int[A];
for(i = 0; i < A; i++)
  {
  fscanf(Input,"%d",&Presionados[i]);
  Presionados[i]--;
  }

fclose(Input);

Output = fopen("Output.txt","w+t");
Resp = Soluciona(P,N,M,A,PiedrasPuerta,Presionados);

Count = 0;
for(i = 0; i < P; i++)
  {
  Resp[i] = Resp[i]%2;
  Count += Resp[i];
  }

fprintf(Output,"%d\n",Count);
for(i = 0; i < P; i++)
  {
  if( Resp[i] == 1 )
	 { fprintf(Output,"%d ",i+1); }
  }

fclose(Output);

delete[] Resp;
for(i = 0; i < N; i++)
  { delete[] PiedrasPuerta[i]; }
delete[] PiedrasPuerta;
delete[] Presionados;

		return 0;
}
//---------------------------------------------------------------------------
